## ros-indigo-motoman-driver 0.3.7

=== CMakeLists.txt ===
# http://ros.org/doc/groovy/api/catkin/html/user_guide/supposed.html
cmake_minimum_required(VERSION 2.8.3)
project(motoman_driver)
# Load catkin and all dependencies required for this package
find_package(
  catkin REQUIRED
  COMPONENTS
    actionlib
    actionlib_msgs
    control_msgs
    industrial_msgs
    industrial_robot_client
    industrial_utils
    motoman_msgs
    roscpp
    roslint
    sensor_msgs
    simple_message
    std_msgs
    std_srvs
    trajectory_msgs
    urdf
)
find_package(Boost REQUIRED COMPONENTS system thread)

roslint_cpp()
#######################################
## Adding directories and definitions #
#######################################
include_directories(include MotoPlus inform ${Boost_INCLUDE_DIR} ${catkin_INCLUDE_DIRS})
add_definitions(-DLINUXSOCKETS=1)  #use linux sockets for communication
add_definitions(-DROS=1)

catkin_package(
  CATKIN_DEPENDS
    actionlib
    actionlib_msgs
    control_msgs
    industrial_msgs
    industrial_robot_client
    industrial_utils
    motoman_msgs
    roscpp
    sensor_msgs
    simple_message
    std_msgs
    std_srvs
    trajectory_msgs
    urdf
  DEPENDS
  INCLUDE_DIRS
    include
  LIBRARIES
)


set(MSG_SRC_FILES
  src/simple_message/motoman_motion_ctrl.cpp
  src/simple_message/motoman_motion_ctrl_message.cpp
  src/simple_message/motoman_motion_reply.cpp
  src/simple_message/motoman_motion_reply_message.cpp
  src/simple_message/messages/motoman_read_single_io_message.cpp
  src/simple_message/messages/motoman_read_single_io_reply_message.cpp
  src/simple_message/messages/motoman_write_single_io_message.cpp
  src/simple_message/messages/motoman_write_single_io_reply_message.cpp
  src/simple_message/motoman_read_single_io.cpp
  src/simple_message/motoman_read_single_io_reply.cpp
  src/simple_message/motoman_write_single_io.cpp
  src/simple_message/motoman_write_single_io_reply.cpp
)

set(CLIENT_SRC_FILES
  src/industrial_robot_client/joint_relay_handler.cpp
  src/industrial_robot_client/joint_feedback_relay_handler.cpp
  src/industrial_robot_client/joint_feedback_ex_relay_handler.cpp
  src/industrial_robot_client/robot_state_interface.cpp
  src/industrial_robot_client/joint_trajectory_interface.cpp
  src/industrial_robot_client/joint_trajectory_streamer.cpp
  src/industrial_robot_client/motoman_utils.cpp
  src/simple_message/joint_feedback_ex.cpp
  src/simple_message/joint_traj_pt_full_ex.cpp
  src/simple_message/messages/joint_feedback_ex_message.cpp
  src/simple_message/messages/joint_traj_pt_full_ex_message.cpp)

###########
## Build ##
###########


#-------------------------------------------------------------
# dx100 uses same byte-ordering as most i386-based PCs

# Simple message library
add_library(motoman_simple_message ${MSG_SRC_FILES})
target_link_libraries(motoman_simple_message
  simple_message)

# Industrial client library
add_library(motoman_industrial_robot_client ${CLIENT_SRC_FILES})
target_link_libraries(motoman_industrial_robot_client
  industrial_robot_client
  industrial_utils)
add_dependencies(motoman_industrial_robot_client ${catkin_EXPORTED_TARGETS})

# Robot state node
add_executable(motoman_robot_state
  src/robot_state_node.cpp)
target_link_libraries(motoman_robot_state
  motoman_simple_message
  motoman_industrial_robot_client
  ${catkin_LIBRARIES})
set_target_properties(motoman_robot_state
  PROPERTIES OUTPUT_NAME robot_state
  PREFIX "")

# Motion streaming node
add_executable(motoman_motion_streaming_interface
  src/joint_streaming_node.cpp
  src/joint_trajectory_streamer.cpp
  src/motion_ctrl.cpp)
target_link_libraries(motoman_motion_streaming_interface
  motoman_simple_message
  motoman_industrial_robot_client
  ${catkin_LIBRARIES})
set_target_properties(motoman_motion_streaming_interface
  PROPERTIES OUTPUT_NAME motion_streaming_interface
  PREFIX "")


#----------------------------------------------------------------
# FS100 uses opposite byte-ordering from most i386-based PCs
# Simple message library
add_library(motoman_simple_message_bswap ${MSG_SRC_FILES})
set_target_properties(motoman_simple_message_bswap PROPERTIES COMPILE_DEFINITIONS "BYTE_SWAPPING")
target_link_libraries(motoman_simple_message_bswap
  simple_message_bswap)

# Industrial client library
add_library(motoman_industrial_robot_client_bswap ${CLIENT_SRC_FILES})
set_target_properties(motoman_industrial_robot_client PROPERTIES COMPILE_DEFINITIONS "BYTE_SWAPPING")
target_link_libraries(motoman_industrial_robot_client_bswap
  industrial_robot_client_bswap
  industrial_utils)
add_dependencies(motoman_industrial_robot_client_bswap ${catkin_EXPORTED_TARGETS})

# Robot state node
add_executable(motoman_robot_state_bswap
  src/robot_state_node.cpp)
target_link_libraries(motoman_robot_state_bswap
  motoman_simple_message_bswap
  motoman_industrial_robot_client_bswap
  ${catkin_LIBRARIES})
set_target_properties(motoman_robot_state_bswap
  PROPERTIES OUTPUT_NAME robot_state_bswap
  PREFIX "")

# Motion streaming node
add_executable(motoman_motion_streaming_interface_bswap
  src/joint_streaming_node.cpp
  src/joint_trajectory_streamer.cpp
  src/motion_ctrl.cpp)
target_link_libraries(motoman_motion_streaming_interface_bswap
  motoman_simple_message_bswap
  motoman_industrial_robot_client_bswap
  ${catkin_LIBRARIES})
set_target_properties(motoman_motion_streaming_interface_bswap
  PROPERTIES OUTPUT_NAME motion_streaming_interface_bswap
  PREFIX "")

add_executable(${PROJECT_NAME}_joint_trajectory_action
  src/joint_trajectory_action_node.cpp
  src/industrial_robot_client/joint_trajectory_action.cpp)
target_link_libraries(${PROJECT_NAME}_joint_trajectory_action
  industrial_robot_client
  motoman_industrial_robot_client
  ${catkin_LIBRARIES})
add_dependencies(${PROJECT_NAME}_joint_trajectory_action ${catkin_EXPORTED_TARGETS})
#############
## Install ##
#############

# binaries
install(TARGETS
    motoman_robot_state
    motoman_motion_streaming_interface
    motoman_robot_state_bswap
    motoman_motion_streaming_interface_bswap
    ${PROJECT_NAME}_joint_trajectory_action

    DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# libraries
install(TARGETS
    motoman_simple_message
    motoman_industrial_robot_client
    motoman_simple_message_bswap
    motoman_industrial_robot_client_bswap

    DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

# headers
install(DIRECTORY include/${PROJECT_NAME}/
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

# other files
foreach(dir Inform launch MotoPlus)
   install(DIRECTORY ${dir}/
      DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/${dir})
endforeach(dir)

install(PROGRAMS src/move_to_joint.py
    DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

=== debian/changelog ===
ros-indigo-motoman-driver (0.3.7-0trusty) trusty; urgency=high

  * Add dep on std_srvs. Fix #159 <https://github.com/ros-industrial/motoman/issues/159>.
  * Contributors: Shaun Edwards, gavanderhoorn

 -- Jeremy Zoss (Southwest Research Institute) <jeremy.zoss@swri.org>  Tue, 21 Mar 2017 05:00:00 -0000

ros-indigo-motoman-driver (0.3.6-0trusty) trusty; urgency=high

  * v1.3.7 MotoROS Driver
    Based on updates from Rosen Diankov (Mujin):
    > Detection of "energy savings" mode.
    > Fix support for R3 and R4 robots.
    > Add function to read torque values. (Not implemented in messaging
    yet.)
    > Improve detection of robot's starting position.
    > Allow for multiple packets to be received in single Recv command.
    > Add command for servo power.
    > Add command to clear alarms/errors.
  * driver: fix whitespace inconsistencies in launch files. (#120 <https://github.com/ros-industrial/motoman/issues/120>)
  * driver: update err msg displayed when 'port' param is not found. (#119 <https://github.com/ros-industrial/motoman/issues/119>)
    IP doesn't have any 'ports', only TCP has those.
  * v1.3.5 MotoROS Driver (#114 <https://github.com/ros-industrial/motoman/issues/114>)
    * v1.3.5 MotoROS Driver
    Update prevents error that would occur if the user's robot controller
    has more control-groups than what is supported by MotoROS and ROS-I.
  * v1.3.6 MotoROS Driver
    Force user to acknowledge that extra control groups are being ignored.
  * v1.3.5 MotoROS Driver
    Update prevents error that would occur if the user's robot controller
    has more control-groups than what is supported by MotoROS and ROS-I.
  * Contributors: G.A. vd. Hoorn, Patrick Beeson, Shaun Edwards, Ted Miller, gavanderhoorn

 -- Jeremy Zoss (Southwest Research Institute) <jeremy.zoss@swri.org>  Mon, 20 Mar 2017 05:00:00 -0000

ros-indigo-motoman-driver (0.3.5-0trusty) trusty; urgency=high

  * Cleaned up issues with Changelogs
  * Contributors: Shaun Edwards

 -- Jeremy Zoss (Southwest Research Institute) <jeremy.zoss@swri.org>  Sun, 03 Jul 2016 05:00:00 -0000

ros-indigo-motoman-driver (0.3.4-0trusty) trusty; urgency=high

  * driver: remove deprecated 'robot_interface.launch' file.
    Deprecated since at least Aug-2013 (9acb8550).
  * Support for multiple motion group control
  * v1.3.4 MotoROS driver
    If a multi-group command is being processed, but one of the groups has
    a full queue, it will respond with a proper ROS_RESULT_BUSY message.  To
    keep everything in sync, none of the groups will be processed.
  * v1.3.3 MotoROS driver
    Improved initialization speed on DX200 controllers.
    Updates to the Parameter Extraction library on DX200 allow faster
    reading from the controller at startup.
  * v1.3.0 MotoROS driver - minor bug fix
    Fix expected byte length for multi-group messages
  * v1.3.1 MotoROS driver
    Added assertion to verify axis-type is valid
    Removed commented code line
  * v1.3.0 MotoROS driver
    Add support for linear axes (such as base track).  Linear position
    data in Meters.
    Fix support for external axes on DX100.
    Fix error code returned for an unknown msgType.
    Modified the size verification on ROS_MSG_MOTO_JOINT_TRAJ_PT_FULL_EX
    messages.  You are not required to send data for four groups if you
    system doesn't have that many groups.* correcting comment to match with launch files: dx100 does not use bswap, FS100 does
  * Fix Issue #62 <https://github.com/shaun-edwards/motoman/issues/62>: motoman_driver CMakeLists.txt missing motoman_msgs dependencies
  * v1.2.5 MotoROS driver
    Fix disconnect logic in the State Server
    Fixed issue with re-connecting to the State Server after closing
    multiple concurrent connections.
  * v1.2.4 Update multi-group message id's
  * v1.2.3 Rename subdirectory for DX200 Inform-job
    No change actual job; just to folder structure.
    Corrected ROS_MSG_JOINT_FEEDBACK_EX message.
    This message will only be sent if the controller has more than one
    control-group.
    Single arm systems will not send this message.
  * v1.2.2
    Corrected the ROS_MSG_MOTO_MOTION_REPLY when replying to
    ROS_MSG_JOINT_TRAJ_PT_FULL_EX.  A motion-reply message will be sent for
    each control group affected by the multi-group-motion message.  The
    motion-reply will correctly indicate the control group index for what it
    represents
  * v1.2.1
    Primitive I/O support
    Added custom Motoman-specific message for reading and writing a single
    I/O point in the controller.
    Note: Write-support is limited to only certain addresses in the robot
    controller.  See wiki for details.
    Fixed multiple-arm support for the DX100 controller.
  * v1.2.0
    Add support for multiple control groups.
    Support for SDA robots, or multiple individual robots and/or external
    axes.
    Add new command message for controlling up to 4 groups.
    Add new position-feedback message to send all group data.
    Add compatibility for DX200 controller.
    Convert MotoPlusIDE projects into Visual Studio solution.
    Maintained legacy compatibility for MPIDE.
    Improve I/O feedback signals.
    Allocate additional signals for future expansion.
    Add more cases where feedback signals are used.
    Improve error handling
    Add additional text and I/O feedback in error cases
  * Contributors: Jeremy Zoss, Maarten de Vries, Sachin Chitta, Shaun Edwards, Ted Miller, Thiago de Freitas Oliveira Araujo, gavanderhoorn, thiagodefreitas

 -- Jeremy Zoss (Southwest Research Institute) <jeremy.zoss@swri.org>  Sun, 03 Jul 2016 05:00:00 -0000

ros-indigo-motoman-driver (0.3.3-0trusty) trusty; urgency=high

  * No changes

 -- Jeremy Zoss (Southwest Research Institute) <jeremy.zoss@swri.org>  Fri, 07 Feb 2014 06:00:00 -0000

ros-indigo-motoman-driver (0.3.2-0trusty) trusty; urgency=high

  * No changes

 -- Jeremy Zoss (Southwest Research Institute) <jeremy.zoss@swri.org>  Fri, 31 Jan 2014 06:00:00 -0000



=== debian/control ===
Source: ros-indigo-motoman-driver
Section: misc
Priority: extra
Maintainer: Jeremy Zoss (Southwest Research Institute) <jeremy.zoss@swri.org>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-actionlib, ros-indigo-actionlib-msgs, ros-indigo-catkin, ros-indigo-control-msgs, ros-indigo-industrial-msgs, ros-indigo-industrial-robot-client, ros-indigo-industrial-utils, ros-indigo-motoman-msgs, ros-indigo-roscpp, ros-indigo-roslint, ros-indigo-sensor-msgs, ros-indigo-simple-message, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-trajectory-msgs, ros-indigo-urdf
Homepage: http://ros.org/wiki/motoman_driver
Standards-Version: 3.9.2

Package: ros-indigo-motoman-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-actionlib, ros-indigo-actionlib-msgs, ros-indigo-control-msgs, ros-indigo-industrial-msgs, ros-indigo-industrial-robot-client, ros-indigo-industrial-utils, ros-indigo-motoman-msgs, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-simple-message, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-trajectory-msgs, ros-indigo-urdf
Description: The motoman driver package includes nodes for interfacing with a motoman industrial robot controllers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-motoman-driver//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
